"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var FormBuilderDraggable_1 = require("./FormBuilderDraggable");
var FormBuilderEditable_1 = require("./FormBuilderEditable");
var FormBuilderDroppable_1 = require("./FormBuilderDroppable");
function createFieldBuilderWrapper() {
    return function (FieldBuilder) {
        return (function (_super) {
            __extends(FieldBuilderWrapper, _super);
            function FieldBuilderWrapper() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            FieldBuilderWrapper.prototype.render = function () {
                var isEditing = (this.props.field.id === this.props.editingFieldId);
                var _a = this.props, onDrop = _a.onDrop, onEditField = _a.onEditField, onDeleteField = _a.onDeleteField, builderProps = __rest(_a, ["onDrop", "onEditField", "onDeleteField"]);
                return (React.createElement(FormBuilderDroppable_1.FormBuilderDroppable, { canDrop: this.props.canDrop, index: this.props.index, onDrop: onDrop, field: this.props.field, parentId: builderProps.parentId },
                    React.createElement(FormBuilderEditable_1.FormBuilderEditable, { deleteButton: this.props.deleteButton, showDeleteButton: true, editButton: this.props.editButton, onEdit: onEditField, onDelete: onDeleteField, index: this.props.index, field: this.props.field, isEditing: isEditing },
                        React.createElement(FormBuilderDraggable_1.FormBuilderDraggable, { canDrag: this.props.canDrag, index: this.props.index, field: this.props.field, parentId: builderProps.parentId },
                            React.createElement(FieldBuilder, __assign({}, builderProps))))));
            };
            return FieldBuilderWrapper;
        }(React.PureComponent));
    };
}
exports.createFieldBuilderWrapper = createFieldBuilderWrapper;
