"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var data = require("../data");
var react_dnd_1 = require("react-dnd");
// FieldSelectorOption displays an option that can be drag and dropped into the FormBuilder.
// When an option is dragged, it will send the field and index (always null) of the option
// to the drag an drop context.
var FieldSelectorOptionComponent = (function (_super) {
    __extends(FieldSelectorOptionComponent, _super);
    function FieldSelectorOptionComponent() {
        var _this = _super.call(this) || this;
        _this.onClick = _this.onClick.bind(_this);
        return _this;
    }
    FieldSelectorOptionComponent.prototype.onClick = function () {
        if (this.props.onClick) {
            this.props.onClick(this.props.field);
        }
    };
    FieldSelectorOptionComponent.prototype.render = function () {
        var _a = this.props, connectDragSource = _a.connectDragSource, field = _a.field, label = _a.label;
        return connectDragSource(React.createElement("div", { className: 'field-selector-option', onClick: this.onClick },
            React.createElement("span", { className: 'field-selector-option-label' }, label)));
    };
    return FieldSelectorOptionComponent;
}(React.Component));
var spec = {
    beginDrag: function (props, monitor, component) {
        return {
            field: props.field,
            index: null,
        };
    }
};
var collect = function (connect, monitor) {
    return {
        connectDragSource: connect.dragSource(),
    };
};
exports.FieldSelectorOption = react_dnd_1.DragSource(data.FIELD_SELECTOR_FIELD, spec, collect)(FieldSelectorOptionComponent);
