"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var data = require("../data");
var react_dnd_1 = require("react-dnd");
var classnames = require("classnames");
// FormBuilderDroppable provides a droppable container that can be used to wrap a field.
// When a field is dropped into the component, it will call the onDrop method and pass
// the field and index of the source field as well as the current field.
// Since the FormBuilder inserts at the index, an insertion line is displayed
// at the top of the droppable space (or above the field).
var FormBuilderDroppableComponent = (function (_super) {
    __extends(FormBuilderDroppableComponent, _super);
    function FormBuilderDroppableComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FormBuilderDroppableComponent.prototype.render = function () {
        var _a = this.props, connectDropTarget = _a.connectDropTarget, canDrop = _a.canDrop;
        return connectDropTarget(React.createElement("div", { className: 'form-builder-droppable' },
            this.props.isOver && React.createElement("div", { className: classnames('form-builder-droppable-indicator', { 'form-builder-droppable-indicator-disabled': !canDrop }) }),
            this.props.children));
    };
    return FormBuilderDroppableComponent;
}(React.Component));
var spec = {
    drop: function (props, monitor) {
        var index = props.index, field = props.field, parentId = props.parentId;
        var source = monitor.getItem();
        var target = { field: field, index: index };
        var didDrop = monitor.didDrop();
        if (monitor.canDrop()) {
            props.onDrop(target, source, didDrop);
        }
    },
    canDrop: function (props, monitor) {
        var field = props.field, index = props.index, parentId = props.parentId, canDrop = props.canDrop;
        var source = monitor.getItem();
        var target = { field: field, index: index, parentId: parentId };
        if (canDrop) {
            // NOTE(andrews): isOver prevents a parent from being considered
            // the drop target when the child is not droppable.
            return monitor.isOver({ shallow: true }) && canDrop(source, target);
        }
        return true;
    }
};
var collect = function (connect, monitor) {
    return {
        isOver: monitor.isOver({ shallow: true }),
        connectDropTarget: connect.dropTarget(),
        canDrop: monitor.canDrop(),
    };
};
exports.FormBuilderDroppable = react_dnd_1.DropTarget([data.FIELD_SELECTOR_FIELD, data.FORM_BUILDER_FIELD], spec, collect)(FormBuilderDroppableComponent);
