/// <reference types="react" />
import * as React from 'react';
import * as data from '../../data';
export interface INestedFormEntryWrapperProps {
    field: data.IField;
    index: number;
    showDeleteButton: boolean;
    onDelete: () => void;
}
export interface INestedFormInputProps {
    createButton?: data.IEditableControlSource;
    onBeforeDeleteEntry?: (value: any) => Promise<boolean>;
    nestedFormEntryWrapper?: React.ComponentClass<INestedFormEntryWrapperProps>;
}
export declare class NestedFormInput extends React.PureComponent<data.IGenericFieldInputProps<data.IField, any[]> & INestedFormInputProps, void> {
    private fieldStatus;
    static defaultProps: data.IFieldInputProps & INestedFormInputProps;
    constructor(props: data.IFieldInputProps & INestedFormInputProps);
    render(): JSX.Element;
    private renderEntry(entry, index);
    private onCreateEntry(event);
    private onDeleteEntry(index);
    private deleteEntry(index);
    private onEntryValueChanged(value, formStatus, index);
    private updateFieldStatus();
    private renderCreateButton();
}
